VERSION 5.00
Begin VB.Form vbdemo 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "VBDEMO: Demo of using WPLOTC32.DLL to control WPlot."
   ClientHeight    =   2640
   ClientLeft      =   900
   ClientTop       =   1548
   ClientWidth     =   7776
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   7.8
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "vbdemo"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2640
   ScaleWidth      =   7776
   Begin VB.CommandButton butok 
      Appearance      =   0  'Flat
      Caption         =   "OK"
      Height          =   372
      Left            =   6240
      TabIndex        =   1
      Top             =   1920
      Width           =   1332
   End
   Begin VB.Label laby 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   " "
      ForeColor       =   &H80000008&
      Height          =   252
      Left            =   3240
      TabIndex        =   3
      Top             =   2280
      Width           =   1452
   End
   Begin VB.Label labx 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   " "
      ForeColor       =   &H80000008&
      Height          =   252
      Left            =   1680
      TabIndex        =   2
      Top             =   2280
      Width           =   1332
   End
   Begin VB.Label labprompt 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Caption         =   " "
      ForeColor       =   &H80000008&
      Height          =   252
      Left            =   120
      TabIndex        =   0
      Top             =   1920
      Width           =   5892
   End
End
Attribute VB_Name = "vbdemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' VBDEMO - Visual Basic Demo of using WPLOTC32.DLL to send commands and
' data to WPlot.  Windows must know the path to WPLOTC32.DLL, i.e., the
' DLL file must be in the directory from which VBDEMO.EXE was launched or
' in the Windows directory or in a directory listed in the PATH environment
' variable or the path to the DLL file must be specified in the declarations
' of the DLL functions.  WPLOT32.EXE must be in the directory from which
' VBDEMO.EXE was launched or in a directory listed in the PATH environment
' variable or the path to WPLOT32.EXE must be specified as a parameter to
' the StartWPlot function.

' If VBDEMO is RUN from Visual Basic rather than compiled to the executable
' file VBDEMO.EXE then the path to WPLOTC32.DLL must be specified in the
' declarations of the DLL functions and the path to WPLOT32.EXE must be
' specified as a parameter to the StartWPlot functions (unless the files are
' in the Windows directory or in a directory listed in the PATH environment
' variable), i.e., Visual Basic does NOT check the directory from which
' VBDEMO.FRM was loaded when RUN.

' Programmers: William G. Hood & Eric A. Hood, 9-16-95, 10-26-97

Option Explicit

'  If VBDEMO is RUN from VB then specify the path to wplotc32.dll,
'  "c:\wplot\wplotc32.dll" for example.
Private Declare Function StartWPlot Lib "wplotc32.dll" (ByVal id As Long, ByVal path As String, ByVal topflag As Long) As Long
Private Declare Function WPlotcmd Lib "wplotc32.dll" (ByVal id As Long, ByVal pcmd As String, ByVal nocheck As Long) As Long

'  Declare Windows routine.
Private Declare Sub UpdateWindow Lib "user32" (ByVal hwnd As Long)

Dim id As Long
Dim state As Long
Dim errmes(4) As String
Dim ydata(8) As Long

Private Sub butok_Click()
  Dim errcode As Long
  Dim i As Long
  Dim x As Double
  Dim y As Double

  Select Case state

    Case 1
      labprompt.Caption = "Starting WPlot ..."
      UpdateWindow (hwnd)

    ' Launch WPlot from VBDEMO.EXE file's working directory; if VBDEMO is RUN
    ' from VB then specify the path to WPlot, "c:\wplot\" for example.
      errcode = StartWPlot(id, "", 0)
      If errcode > 0 Then
        If errcode > 5 Then errcode = 5
        MsgBox errmes(errcode - 1), 16, "ERROR"
        End
      End If
       
      send id, "winpos 0.5 45.0"  ' Set window position
      send id, "plotsize 1"       ' Set small plot size
      
      labprompt.Caption = " Press the OK button to see a plot of data sent to WPlot."
      state = 2

    Case 2
      labprompt.Caption = "Sending data and plot commands to WPlot ..."
      UpdateWindow (hwnd)

      send id, "title Demo of Controlling WPlot"
      send id, "xlabel X-Axis"
      send id, "ylabel Y-Axis"
      send id, "xstart 0"
      send id, "xend 10"
      send id, "xstep 1"
      send id, "ystart 0"
      send id, "yend 1000"
      send id, "ystep 200"
      send id, "grids"
      send id, "read 9"     ' Data points can be sent after a READ command
      For i = 0 To 8
        send id, Str$(i + 1) + " " + Str$(ydata(i))
      Next i
      send id, "curve 1"    ' The data set will be plotted as a smooth curve.
      send id, "symbols"    ' A symbol will be plotted at each data point.
      send id, "plot"       ' Plot previously read data points.

      labprompt.Caption = " Press the OK button to plot data points as they are calculated."
      state = 3

    Case 3
      labprompt.Caption = "Calculating and plotting data points ..."
      UpdateWindow (hwnd)

  ' Some special commands were added to WPlot for real-time data display:
  ' rtdata   m     - Allocates memory for a maximum of m data points.
  ' rtpoint  x  y  - Plots point (x,y).
  ' rtend          - Terminates real-time plot & frees Windows resources.
      send id, "rtdata 51"
      For i = 0 To 50
        x = i / 5#
        y = x ^ 3 + 2# * x ^ 2 - 30# * x + 90
        y = y + 20# * (2# * Rnd - 1)
        labx.Caption = " X = " + Format(x, "0.00")
        laby.Caption = " Y = " + Format(y, "0.00")
        UpdateWindow (hwnd)
        send id, "rtpoint " + Str$(x) + " " + Str$(y)
      Next i
      send id, "rtend"

      labprompt.Caption = " Press the OK button to make a polynomial curve fit."
      state = 4

    Case 4
      labprompt.Caption = ""
      UpdateWindow (hwnd)

      send id, "poly 3"
      send id, "title Polynomial Curve Fit"
      send id, "plot"

      labprompt.Caption = " Press the OK button to exit."
      labx.Caption = ""
      laby.Caption = ""
      state = 5

    Case 5
      send id, "exit"
      End

  End Select

End Sub

Private Sub Form_Load()
  Left = 2   ' Position form at upper left corner of screen
  Top = 2
  
  id = 1
  state = 1
  
  errmes(0) = " Out of Memory"
  errmes(1) = " Invalid ID"
  errmes(2) = " File WPLOT32.EXE not found"
  errmes(3) = " Path to WPLOT32.EXE not found"
  errmes(4) = " Unspecified error"

  ydata(0) = 125  ' Example data
  ydata(1) = 175
  ydata(2) = 350
  ydata(3) = 750
  ydata(4) = 900
  ydata(5) = 750
  ydata(6) = 350
  ydata(7) = 175
  ydata(8) = 125
  
  Print
  Print "  WPlot can be used to plot data collected, calculated, or processed by a user written C"
  Print "  or Visual Basic program."
  Print
  Print "  This is an example of a Visual Basic program that plots data by sending the data and"
  Print "  plot commands to WPlot using functions in the Dynamic Link Library WPLOTC32.DLL;"
  Print "  see the Visual Basic source code in files VBDEMO.FRM and VBDEMO.MAK."
  Print
  Print "  Files WPLOTC32.DLL and WPLOT32.EXE must be in VBDEMO's working directory."
  
  labprompt.ForeColor = QBColor(12)  ' Light Red
  labprompt.Caption = " Press the OK button to start WPlot."
End Sub

Private Sub send(id As Long, cmd As String)
' Sends command in string pcmd to WPLOTC32.DLL using buffer #id.
' The routine keeps trying until the DLL is ready to accept the command.
' It displays an error message and terminates if it times out after 20 seconds.

  Dim tstart As Long

  tstart = Timer
  Do
    If WPlotcmd(id, cmd, 0) = 0 Then Exit Sub
  Loop While Timer - tstart < 20
  
  MsgBox "WPlot is not responding", 16, "ERROR"
  End
End Sub
