// WPLOTC32.H - C Header file for WPLOTC32.DLL used to send commands & data
// to WPlot.  Hooks to these functions will be linked to the user's program if
// the Borland import library file WPLOTC32.LIB is specified in the project
// file or if the following code is included in the program's DEF file:
// IMPORTS  WPLOTC32.StartWPlot
//          WPLOTC32.WPlotcmd

// Note: CALLBACK and BOOL are defined in windows.h

int CALLBACK StartWPlot( int id, char *path, BOOL WPlotOnTop );
// Starts WPlot with parameter "#n" where n is a specified buffer id (1 to 4).
// The id allows up to 4 different instances of WPlot to be controlled.
// The path to WPlot is specified by the second parameter (may be NULL).
// If the path specifies a directory then it must be followed by a "\".
// WPlot will be the foreground window if the third parameter is TRUE.
// Returns 0 if successfull, else one of the following error codes:
// 1: Out of memory, 2: Invalid id, 3: File not found, 4: Path not found
// 5 or greater: unspecified error.

int CALLBACK WPlotcmd( int id, char *pcmd, BOOL nocheck );
// Puts command pointed to by pcmd into internal buffer associated with id if
// the buffer is empty.  Returns 0 if successfull; returns 1 if the buffer is
// not empty, i.e. the buffer has not yet been read by WPlot.  The test for
// an empty buffer is disabled if nocheck is nonzero.  WPlotcmd can be called
// with pcmd = NULL (and nocheck = 0) to just check that the buffer is empty.
// chance to read the previous command.
